platform                   = {}
player                     = {}
enemy                      = {}
enemies                    = {}
enemies_controller         = {}
enemies_controller.enemies = {}

function love.load()
    --background = love.graphics.newImage('background.png')
    
	platform.width = love.graphics.getWidth()
	platform.height = love.graphics.getHeight()
 
	platform.x = 0
	platform.y = platform.height / 2
 
	player.x = love.graphics.getWidth() / 2
	player.y = love.graphics.getHeight() / 2.05
 
	player.speed = 200
 
	player.img = love.graphics.newImage('minion.png')
 
	player.ground = player.y
 
	player.y_velocity = 0
 
	player.jump_height = -300
	player.gravity = -500
  
    enemy.x = love.graphics.getWidth() / 2.05
    enemy.y = love.graphics.getHeight() / 2.05
    
    enemy.img = love.graphics.newImage('minion.png')
    
    enemy.ground = player.y
    
    enemy.y_velocity = 0
  
    enemy.bullets  = {}
    enemy.cooldown = 30
    enemy.fire = function()
        bullet = {
            x = enemy.x,
            y = enemy.y,
            angle = math.atan2(player.y - enemy.y, player.x - enemy.x),
            speed = 20
        }

        table.insert(enemy.bullets, bullet)
    end
end
 
function love.update(dt)
	if love.keyboard.isDown('d') then
		if player.x < (love.graphics.getWidth() - player.img:getWidth()) then
			player.x = player.x + (player.speed * dt)
		end
	elseif love.keyboard.isDown('a') then
		if player.x > 0 then 
			player.x = player.x - (player.speed * dt)
		end
    end
 
	if love.keyboard.isDown('space') then
		if player.y_velocity == 0 then
			player.y_velocity = player.jump_height
		end
	end
 
	if player.y_velocity ~= 0 then
		player.y = player.y + player.y_velocity * dt
		player.y_velocity = player.y_velocity - player.gravity * dt
	end
 
	if player.y > player.ground then
		player.y_velocity = 0
    	player.y = player.ground
    end
    
    if love.keyboard.isDown('e') then
       enemy.fire()
    end

    for _,bullet in pairs(enemy.bullets) do
        bullet.x = bullet.x + math.cos(bullet.angle) * bullet.speed
        bullet.y = bullet.y + math.sin(bullet.angle) * bullet.speed
    end
end
 
function love.draw()
    love.graphics.setColor(255, 255, 255)
    --love.graphics.draw(background, 1, 1, 0, 1.6, 1.2, 3)
  
	love.graphics.setColor(50, 100, 150)
	love.graphics.rectangle('fill', platform.x, platform.y, platform.width, platform.height)
 
    love.graphics.setColor(255, 255, 255)
    love.graphics.draw(player.img, player.x, player.y)
    
    love.graphics.draw(enemy.img, enemy.x, enemy.y)
  
  -- draw bullets
    love.graphics.setColor(255, 255, 255)
    for _,v in pairs(enemy.bullets) do
        love.graphics.rectangle("fill", v.x, v.y, 5, 5)
    end
end